library ac_dart.descriptor.builder.confluence.impl;

import 'package:atlassian_connect_host/atlassian_connect_host.dart';
import 'package:atlassian_connect_shelf/src/descriptor_builders/confluence.dart';
import 'package:atlassian_connect_shelf/src/descriptor_builders/standard_impl.dart';
import 'package:constrain/constrain.dart';
import 'package:logging/logging.dart';
import 'package:mojito/mojito.dart';

final Validator _validator = new Validator();

Logger _log = new Logger('ac_dart.descriptor.builder.confluence.impl');

class ConfluenceDescriptorBuilderImpl extends StandardDescriptorBuilderImpl<
    ConfluenceModuleList,
    ConfluenceScope,
    ConfluenceConnectAddon> implements ConfluenceDescriptorBuilder {
//  final List<Page> _repoPages = [];

  ConfluenceDescriptorBuilderImpl(String addonKey, Uri baseUrl)
      : super(addonKey, baseUrl);

  ConfluenceConnectAddon build(DefaultRouter rootRouter, Vendor vendor,
      {String name,
      String description,
      ClientId oauthClientId,
      Iterable<ConfluenceScope> scopes}) {
    final addon = new ConfluenceConnectAddon(
        key: addonKey,
        name: name,
        description: description,
        baseUrl: baseUrl,
        authentication:
            new Authentication(type: AuthenticationType.JWT), // TODO
        modules: buildModules(rootRouter, new Option(oauthClientId)),
        lifecycle: buildLifecycle(rootRouter),
        vendor: vendor,
        scopes: scopes);

    final constraints = _validator.validate(addon);

    if (constraints.isNotEmpty) {
      _log.severe('addon descriptor is invalid: $constraints');
    }

    return addon;
  }

  @override
  ConfluenceModuleList buildProductModules(
      Iterable<ClassifiedModule> coreModules, DefaultRouter rootRouter) {
    return new ConfluenceModuleList.fromModules(coreModules);
  }

//  @override
//  void addRepoPage(String key, String name, ConfluenceLocation location) {
//    addPage(ConfluenceModuleTypes.repoPage, key, name, location);
//  }
}
