library ac_dart.descriptor.builder.jira.impl;

import 'package:atlassian_connect_host/atlassian_connect_host.dart';
import 'package:atlassian_connect_shelf/src/descriptor_builders/jira.dart';
import 'package:atlassian_connect_shelf/src/descriptor_builders/standard_impl.dart';
import 'package:constrain/constrain.dart';
import 'package:logging/logging.dart';
import 'package:mojito/mojito.dart';

final Validator _validator = new Validator();

Logger _log = new Logger('ac_dart.descriptor.builder.jira.impl');

class JiraDescriptorBuilderImpl extends StandardDescriptorBuilderImpl<
    JiraModuleList,
    JiraScope,
    JiraConnectAddon> implements JiraDescriptorBuilder {
//  final List<Page> _repoPages = [];

  JiraDescriptorBuilderImpl(String addonKey, Uri baseUrl)
      : super(addonKey, baseUrl);

  JiraConnectAddon build(DefaultRouter rootRouter, Vendor vendor,
      {String name,
      String description,
      ClientId oauthClientId,
      Iterable<JiraScope> scopes}) {
    final addon = new JiraConnectAddon(
        key: addonKey,
        name: name,
        description: description,
        baseUrl: baseUrl,
        authentication:
            new Authentication(type: AuthenticationType.JWT), // TODO
        modules: buildModules(rootRouter, new Option(oauthClientId)),
        lifecycle: buildLifecycle(rootRouter),
        vendor: vendor,
        scopes: scopes);

    final constraints = _validator.validate(addon);

    if (constraints.isNotEmpty) {
      _log.severe('addon descriptor is invalid: $constraints');
    }

    return addon;
  }

  @override
  JiraModuleList buildProductModules(
      Iterable<ClassifiedModule> coreModules, DefaultRouter rootRouter) {
    return new JiraModuleList.fromModules(coreModules);
  }

//  @override
//  void addRepoPage(String key, String name, JiraLocation location) {
//    addPage(JiraModuleTypes.repoPage, key, name, location);
//  }
}
