library ac_dart.addon_routebuilder.common;

import 'dart:async';

import 'package:atlassian_connect_host/atlassian_connect_host.dart';

typedef Future InstallationHandler(
    InstallationEvent installationEvent, AcHostService hostService);

abstract class CommonAddonRouterBuilder<S extends Scope> {
  void addDescriptorRoute(Vendor vendor, String name, String description,
      {String path: 'descriptor', Iterable<S> scopes: const []});

  void addInstallationRoute({String path: 'installed'});

  void addSpaRedirect(path, String name,
      {String spaBasePath: 'ui',
      String fragmentPath,
      Map<String, String> additionalUriFragmentParams: const {}});

  void get(path, String name, Function handler);
}
