library ac_dart.addon_routebuilder.standard;

import 'package:atlassian_connect_shelf/src/router/common/common_routes.dart';

/// standard routes (i.e. for non hipchat)
abstract class StandardAddonRouterBuilder<S extends Scope,
    L extends ModuleLocation> implements CommonAddonRouterBuilder<S> {
  void addSpaPage(String moduleType, path, String key, String name, L location,
      {String spaBasePath,
      String fragmentPath,
      Map<String, String> additionalUriFragment: const {}});

  void addPage(String moduleType, path, String key, String name, L location,
      Function handler);

  void addWebhook(path, String event, String name, Function handler,
      {Map<String, Object> params: const {}});

  void addSpaGeneralPage(path, String key, String name, L location,
      {String spaBasePath,
      String fragmentPath,
      Map<String, String> additionalUriFragment: const {}});

  void addSpaAdminPage(path, String key, String name, L location,
      {String spaBasePath,
      String fragmentPath,
      Map<String, String> additionalUriFragment: const {}});
}
