library ac_dart.addon_routebuilder.jira.impl;

import 'package:atlassian_connect_host/atlassian_connect_host.dart';
import 'package:atlassian_connect_shelf/router.dart' hide router;
import 'package:atlassian_connect_shelf/src/descriptor_builders/jira.dart';
import 'package:atlassian_connect_shelf/src/descriptor_builders/jira_impl.dart';
import 'package:atlassian_connect_shelf/src/router/common/standard_routes_impl.dart';
import 'package:atlassian_connect_shelf/src/router/jira/jira.dart';
import 'package:logging/logging.dart';
import 'package:mojito/mojito.dart' hide Router, router;
import 'package:shelf_auth/shelf_auth.dart';

final Logger _log = new Logger('ac_dart.addon_routebuilder.jira');

class JiraRouterBuilderImpl extends StandardAddonRouterBuilderImpl<
    JiraModuleList,
    JiraScope,
    JiraConnectAddon,
    JiraDescriptorBuilder,
    JiraLocation> implements JiraRouterBuilder {
  JiraRouterBuilderImpl(
      Router router,
      path,
      String addonKey,
      Uri baseUrl,
      AcHostRegistrationRepository hostRegistrationRepository,
      IsDevMode isDevMode,
      {SessionHandler sessionHandler,
      String addonSecret})
      : super(router, path, new JiraDescriptorBuilderImpl(addonKey, baseUrl),
            addonKey, baseUrl, hostRegistrationRepository, isDevMode,
            sessionHandler: sessionHandler, addonSecret: addonSecret);

//  void addSpaRepoPage(path, String key, String name, JiraLocation location,
//      {String spaBasePath,
//      String fragmentPath,
//      Map<String, String> additionalUriFragment: const {}}) {
//    addSpaPage(JiraModuleTypes.repoPage, path, key, name, location,
//        spaBasePath: spaBasePath,
//        fragmentPath: fragmentPath,
//        additionalUriFragment: additionalUriFragment);
//  }

//  @override
//  void addRepoPage(
//      path, String key, String name, JiraLocation location, Function handler) {
//    addPage(JiraModuleTypes.repoPage, path, key, name, location, handler);
//  }
}
